/*
  extppt.c

  External interface dispatcher to parallel port digital I/O

  Modification history:

  13-Mar-2000 WPS added unused attribute to parport_h to avoid 'defined but not used' compiler warning, and added (void) to functions with no arguments to avoid 'declaration is not a prototype' compiler warnings.
  7-Aug-1998  FMP changed extInit/Quit() to extDioInit/Quit()
  */

#include "extintf.h"            /* these decls */
#include "parport.h"            /* parport decls */

/* ident tag */
#ifndef __GNUC__
#ifndef __attribute__
#define __attribute__(x)
#endif
#endif

static char __attribute__((unused)) ident[] = "$Id: extppt.c,v 1.1.1.1 2005/05/31 11:12:19 paul Exp $";

int extDioInit(const char * stuff)
{
  return pptDioInit(stuff);
}

int extDioQuit(void)
{
  return pptDioQuit();
}

int extDioMaxInputs(void)
{
  return pptDioMaxInputs();
}

int extDioMaxOutputs(void)
{
  return pptDioMaxOutputs();
}

int extDioRead(int index, int *value)
{
  return pptDioRead(index, value);
}

int extDioWrite(int index, int value)
{
  return pptDioWrite(index, value);
}

int extDioCheck(int index, int *value)
{
  return pptDioCheck(index, value);
}

int extDioByteRead(int index, unsigned char *byte)
{
  return pptDioByteRead(index, byte);
}

int extDioByteWrite(int index, unsigned char byte)
{
  return pptDioByteWrite(index, byte);
}

int extDioByteCheck(int index, unsigned char *byte)
{
  return pptDioByteCheck(index, byte);
}
