/*
  extsimaio.c

  Dispatcher of external functions to simulated digital IO implementation.

  Modification history:

  20-Mar-2000 WPS added unused attribute to ident to avoid 'defined but not used' compiler warning
  7-Aug-1998  FMP created from analog portion of extsimdio.c
  */

#include "extintf.h"            /* these decls */
#include "sim.h"                /* decls for sim implementation */

/* ident tag */
#ifndef __GNUC__
#ifndef __attribute__
#define __attribute__(x)
#endif
#endif

static char __attribute__((unused)) ident[] = "$Id: extsimaio.c,v 1.1.1.1 2005/05/31 11:12:19 paul Exp $";

int extAioInit(const char * stuff)
{
  return simAioInit(stuff);
}

int extAioQuit(void)
{
  return simAioQuit();
}

int extAioMaxInputs(void)
{
  return simAioMaxInputs();
}

int extAioMaxOutputs(void)
{
  return simAioMaxOutputs();
}

int extAioRead(int index, double *volts)
{
  return simAioRead(index, volts);
}

int extAioWrite(int index, double volts)
{
  return simAioWrite(index, volts);
}

int extAioCheck(int index, double *volts)
{
  return simAioCheck(index, volts);
}

int extAioReady(void){return 0;}
