/*
  extsimdio.c

  Dispatcher of external functions to simulated digital IO implementation.

  Modification history:

  20-Mar-2000 WPS added unused attribute to ident to avoid 'defined but not used' compiler warning
  7-Aug-1998  FMP split into dio and aio files; changed extInit/Quit()
  to extDioInit/Quit()
  31-Mar-1998  FMP added analog IO
  18-Mar-1998  FMP split out from extsim.c
  25-Nov-1997 FMP changed extLimitSwitchRead to extPos,NegLimit...
  18-Nov-1997 FMP added dio functions
  16-Oct-1997  FMP created
  */

#include "extintf.h"            /* these decls */
#include "sim.h"                /* decls for sim implementation */

/* ident tag */
#ifndef __GNUC__
#ifndef __attribute__
#define __attribute__(x)
#endif
#endif

static char __attribute__((unused)) ident[] = "$Id: extsimdio.c,v 1.1.1.1 2005/05/31 11:12:19 paul Exp $";

int extDioInit(const char * stuff)
{
  return simDioInit(stuff);
}

int extDioQuit(void)
{
  return simDioQuit();
}

int extDioMaxInputs(void)
{
  return simDioMaxInputs();
}

int extDioMaxOutputs(void)
{
  return simDioMaxOutputs();
}

int extDioRead(int index, int *value)
{
  return simDioRead(index, value);
}

int extDioWrite(int index, int value)
{
  return simDioWrite(index, value);
}

int extDioCheck(int index, int *value)
{
  return simDioCheck(index, value);
}

int extDioByteRead(int index, unsigned char *byte)
{
  return simDioByteRead(index, byte);
}

int extDioByteWrite(int index, unsigned char byte)
{
  return simDioByteWrite(index, byte);
}

int extDioByteCheck(int index, unsigned char *byte)
{
  return simDioByteCheck(index, byte);
}
