/*
  extsim.c

  Dispatcher of external functions to simulated implementation.

  Modification history:

   14-Apr-2000 WPS added _attribute__((unused)) to ident
  7-Aug-1998  FMP changed extInit/Quit to extMotInit/Quit()
  8-Jul-1998  FMP changed EMC_INIFILE to EMCMOT_INIFILE
  18-Mar-1998  FMP split out from extsim.c
  25-Nov-1997 FMP changed extLimitSwitchRead to extPos,NegLimit...
  18-Nov-1997 FMP added dio functions
  16-Oct-1997  FMP created
  */

#include "extintf.h"            /* these decls */
#include "sim.h"                /* decls for sim implementation */
/* FIXME-- this header is installed in emcmot/, after emcsim/ is compiled */
#include "emcmotglb.h"          /* EMCMOT_INIFILE */

/* ident tag */
#ifndef __GNUC__
#ifndef __attribute__
#define __attribute__(x)
#endif
#endif

static char __attribute__((unused)) ident[] = "$Id: extsimmot.c,v 1.1.1.1 2005/05/31 11:12:19 paul Exp $";

int extMotInit(const char * stuff)
{
  /* pass the name of the ini file here */
  return simMotInit(EMCMOT_INIFILE);
}

int extMotQuit(void)
{
  return simMotQuit();
}

int extDacNum(void)
{
  return simDacNum();
}

int extDacWrite(int dac, double volts)
{
  return simDacWrite(dac, volts);
}

int extDacWriteAll(int max, double * volts)
{
  return simDacWriteAll(max, volts);
}

int extEncoderSetIndexModel(unsigned int model)
{
  return simEncoderSetIndexModel(model);
}

int extEncoderNum(void)
{
  return simEncoderNum();
}

int extEncoderRead(int encoder, double * counts)
{
  return simEncoderRead(encoder, counts);
}

int extEncoderReadAll(int max, double * counts)
{
  return simEncoderReadAll(max, counts);
}

int extEncoderResetIndex(int encoder)
{
  return simEncoderResetIndex(encoder);
}

int extEncoderReadLatch(int encoder, int * flag)
{
  return simEncoderReadLatch(encoder, flag);
}

int extEncoderReadLevel(int encoder, int * flag)
{
  return simEncoderReadLevel(encoder, flag);
}

int extMaxLimitSwitchRead(int axis, int * flag)
{
  return simMaxLimitSwitchRead(axis, flag);
}

int extMinLimitSwitchRead(int axis, int * flag)
{
  return simMinLimitSwitchRead(axis, flag);
}

int extHomeSwitchRead(int axis, int * flag)
{
  return simHomeSwitchRead(axis, flag);
}

int extAmpEnable(int axis, int enable)
{
  return simAmpEnable(axis, enable);
}

int extAmpFault(int axis, int * fault)
{
  return simAmpFault(axis, fault);
}
