/*
  extmmio.c

  Dispatcher of external functions for NIST minimill

  Modification history:

  7-Aug-1998  FMP changed extInit/Quit to extDio/AioInit/Quit()
  2-Apr-1998  FMP used sim implementation since can't share STG with
  RT motion system
  1-Apr-1998  FMP created
  */

#include "extintf.h"            /* these decls */
#include "sim.h"                /* decls for sim implementation */

/* ident tag */
/* ident tag */
#ifndef __GNUC__
#ifndef __attribute__
#define __attribute__(x)
#endif
#endif

static char __attribute__((unused)) ident[] = "$Id: extminimillio.c,v 1.1.1.1 2005/05/31 11:12:19 paul Exp $";

int extDioInit(const char * stuff)
{
  return simDioInit(stuff);
}

int extDioQuit()
{
  return simDioQuit();
}

int extDioMaxInputs()
{
  return simDioMaxInputs();
}

int extDioMaxOutputs()
{
  return simDioMaxOutputs();
}

int extDioRead(int index, int *value)
{
  return simDioRead(index, value);
}

int extDioWrite(int index, int value)
{
  return simDioWrite(index, value);
}

int extDioCheck(int index, int *value)
{
  return simDioCheck(index, value);
}
#if 0
int extDioByteRead(int index, unsigned char *byte)
{
  return simDioByteRead(index, byte);
}

int extDioByteWrite(int index, unsigned char byte)
{
  return simDioByteWrite(index, byte);
}

int extDioByteCheck(int index, unsigned char *byte)
{
  return simDioByteCheck(index, byte);
}
#endif
int extAioInit(const char * stuff)
{
  return simAioInit(stuff);
}

int extAioQuit()
{
  return simAioQuit();
}

int extAioMaxInputs()
{
  return simAioMaxInputs();
}

int extAioMaxOutputs()
{
  return simAioMaxOutputs();
}

int extAioRead(int index, double *volts)
{
  return simAioRead(index, volts);
}

int extAioWrite(int index, double volts)
{
  return simAioWrite(index, volts);
}

int extAioCheck(int index, double *volts)
{
  return simAioCheck(index, volts);
}
