#ifndef PATHSEG_H_
#define PATHSEG_H_

#include "posemath.h"
#include "emcpos.h"

#define PATHSEG_ROTATIONAL 0
#define PATHSEG_LINEAR 1
#define PATHSEG_CIRCULAR 2

typedef struct {
    int segType;		/* PATHSEG_LINEAR, PATHSEG_CIRCULAR, PATHSEG_ROTATIONAL */
    double length;		/* arc length for translations, equivalent for rots */
    EmcPose start;
    EmcPose end;
    PmCircle circle;
} PathSeg;

extern void pathsegInitLinear(PathSeg * seg, EmcPose start, EmcPose end);
extern void pathsegInitCircular(PathSeg * seg, EmcPose start, EmcPose end,
				PmCartesian center, PmCartesian normal,
				int turn);
extern EmcPose pathsegGetPos(PathSeg * seg, double arcpos);
extern PmCartesian pathsegGetStartDirection(PathSeg * seg);
extern PmCartesian pathsegGetEndDirection(PathSeg * seg);

#endif				/*PATHSEG_H_ */
