#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@"

# this routines supports the generation of g code
# to drill a circular pattern of holes
# written By Lawrence P Glaister VE7IT Dec 2000

;;#######################################################################
if { ![info exists caholes(mopName)] || $caholes(mopName) == "" } {
    # init for convenience
    set caholes(mopName) "CAHoles"
    set caholes(CenterX) 2
    set caholes(CenterY) 2
    set caholes(CircDia) 2.5
    set caholes(HoleDepth) 0.5
    set caholes(NumPattern) 8
    set caholes(NumHoles) 6
    set caholes(FeedRate) 5
    set caholes(SafeZ) 0.5
    set caholes(Comment) "Drill Circular Array of Holes"
}

;;#######################################################################
;# Build frame to enter mop parameters

set mopArgs [frame $cp.mopArgs -relief flat ]

foreach field [array names caholes] {
#    puts $field
    label $mopArgs.l$field -text $field -anchor w
    entry $mopArgs.e$field -textvariable caholes($field) -relief sunken
}

# Put arguments two to a row.  
grid    $mopArgs.lComment   -sticky e
grid    $mopArgs.eComment  -row 0 -column 1   -sticky nsew
grid configure $mopArgs.eComment -columnspan 3

grid    $mopArgs.lCenterX       $mopArgs.eCenterX           \
	    $mopArgs.lCenterY       $mopArgs.eCenterY    -sticky e

grid    $mopArgs.lCircDia       $mopArgs.eCircDia           \
	    $mopArgs.lHoleDepth     $mopArgs.eHoleDepth  -sticky e

grid    $mopArgs.lNumPattern    $mopArgs.eNumPattern        \
	    $mopArgs.lNumHoles      $mopArgs.eNumHoles   -sticky e

grid    $mopArgs.lFeedRate      $mopArgs.eFeedRate          \
	    $mopArgs.lSafeZ         $mopArgs.eSafeZ      -sticky e



# The name of the file that is sourced when mop RUN button pressed
set mopRunFile "makeCAHoles.tcl"

# The name of the array containing the arguments
set mopName "caholes"

# The name of the file that is sourced when mop HELP button pressed
set mopHelpFile "CAHolesHelp.txt"

