#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@"

# The arguments and gui for engraving txt
# 
# Lawrence Glaister VE7IT  Nov 2000

;;#######################################################################
if { ![info exists engrave(mopName)] || $engrave(mopName) == "" } {
    # init for convenience
    set engrave(mopName) "Engrave"
    set engrave(StartX) 0.0
    set engrave(StartY) 0.0
    set engrave(Height) 0.5
    set engrave(Angle) 0.0
    set engrave(FlipX) "N"
    set engrave(FlipY) "N"    
    set engrave(CutZ) -0.050
    set engrave(SafeZ) +0.25
    set engrave(FeedRate) 10
    set engrave(EText) "THIS IS A TEST"
    set engrave(Comment) "Engrave A Text String "
}

;;#######################################################################
;# Build frame to enter mop parameters

set mopArgs [frame $mop.mopArgs -relief flat]

puts "engraveGui test"

foreach field [array names engrave] {
#    puts $field
    label $mopArgs.l$field -text $field -anchor w
    entry $mopArgs.e$field -textvariable engrave($field) -relief sunken
}

# Put arguments two to a row.
grid    $mopArgs.lComment   -sticky e
grid    $mopArgs.eComment  -row 0 -column 1   -sticky nsew
grid configure $mopArgs.eComment -columnspan 3

grid    $mopArgs.lStartX        $mopArgs.eStartX        \
	    $mopArgs.lStartY        $mopArgs.eStartY     -sticky e

grid    $mopArgs.lHeight        $mopArgs.eHeight        \
	    $mopArgs.lAngle         $mopArgs.eAngle      -sticky e

grid    $mopArgs.lFlipX         $mopArgs.eFlipX         \
        $mopArgs.lFlipY         $mopArgs.eFlipY      -sticky e

grid    $mopArgs.lCutZ          $mopArgs.eCutZ          \
        $mopArgs.lSafeZ         $mopArgs.eSafeZ      -sticky e

grid    $mopArgs.lFeedRate      $mopArgs.eFeedRate   -sticky e
        
grid    $mopArgs.lEText     -sticky e   
grid    $mopArgs.eEText  -row 6 -column 1   -sticky nsew
grid configure $mopArgs.eEText -columnspan 3
        


# The name of the file that is sourced when mop RUN button pressed
set mopRunFile "makeEngrave.tcl"

# The name of the array containing the arguments
set mopName "engrave"

# The name of the file that is sourced when mop HELP button pressed
set mopHelpFile "EngraveHelp.txt"

