#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@"

# The arguments and gui for makeGrill
# drilling round array of holes for ventilation/speakers.
# Lawrence Glaister VE7IT  Nov 2000

;;#######################################################################
if { ![info exists grill(mopName)] || $grill(mopName) == "" } {
    # init for convenience
    set grill(mopName) "Grill"
    set grill(CenterX) 0
    set grill(CenterY) 0
    set grill(Incr) 0.25
    set grill(Radius) 2.0
    set grill(HoleDepth) 0.5
    set grill(SafeZ) 0.25
    set grill(FeedRate) 5
    set grill(Comment) "Drill a Grill - Speaker/Vent"
}

;;#######################################################################
;# Build frame to enter mop parameters

set mopArgs [frame $mop.mopArgs -relief flat]

foreach field [array names grill] {
#    puts $field
    label $mopArgs.l$field -text $field -anchor w
    entry $mopArgs.e$field -textvariable grill($field) -relief sunken
}

# Put arguments two to a row.
grid    $mopArgs.lComment   -sticky e
grid    $mopArgs.eComment  -row 0 -column 1   -sticky nsew
grid configure $mopArgs.eComment -columnspan 3

grid    $mopArgs.lCenterX     $mopArgs.eCenterX      \
	    $mopArgs.lCenterY     $mopArgs.eCenterY      -sticky e

grid    $mopArgs.lIncr      $mopArgs.eIncr       \
	    $mopArgs.lRadius      $mopArgs.eRadius      -sticky e

grid    $mopArgs.lHoleDepth $mopArgs.eHoleDepth    \
        $mopArgs.lSafeZ     $mopArgs.eSafeZ        -sticky e

grid    $mopArgs.lFeedRate   $mopArgs.eFeedRate    -sticky e

# The name of the file that is sourced when mop RUN button pressed
set mopRunFile "makeGrill.tcl"

# The name of the array containing the arguments
set mopName "grill"

# The name of the file that is sourced when mop HELP button pressed
set mopHelpFile "GrillHelp.txt"

