#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@"

# The arguments and gui for makeHole.
# Sandor Szabo, NIST, 12/6/99

;;#######################################################################
if { ![info exists hole(CenterX)] || $hole(CenterX) == "" } {
    # init for convenience
    set hole(mopName) "hole"
    set hole(CenterX) 1
    set hole(CenterY) 2
    set hole(ToolDia) .125
    set hole(BoreDia) .5
    set hole(FeedRate) 10
    set hole(WidthOfCut) .05
    set hole(FinishFeed) 5
    set hole(FinishWOC) .01
    set hole(DepthPerPass) .05
    set hole(BoreDepth) .1
    set hole(Comment) "Mill a Circular Pocket"
}

;;#######################################################################
;# Build frame to enter mop parameters

set mopArgs [frame $cp.mopArgs -relief flat]

foreach field [array names hole] {
    label $mopArgs.l$field -text $field -anchor w
    entry $mopArgs.e$field -textvariable hole($field) -relief sunken
}

# Put arguments two to a row.
grid    $mopArgs.lComment -sticky e
grid    $mopArgs.eComment  -row 0 -column 1   -sticky nsew
grid configure $mopArgs.eComment -columnspan 3
grid    $mopArgs.lCenterX      $mopArgs.eCenterX      \
	$mopArgs.lCenterY      $mopArgs.eCenterY      -sticky e
grid    $mopArgs.lToolDia      $mopArgs.eToolDia      \
	$mopArgs.lBoreDia      $mopArgs.eBoreDia      -sticky e
grid    $mopArgs.lFeedRate     $mopArgs.eFeedRate     \
	$mopArgs.lWidthOfCut   $mopArgs.eWidthOfCut   -sticky e
grid    $mopArgs.lFinishFeed   $mopArgs.eFinishFeed   \
	$mopArgs.lFinishWOC    $mopArgs.eFinishWOC    -sticky e
grid    $mopArgs.lDepthPerPass $mopArgs.eDepthPerPass \
	$mopArgs.lBoreDepth    $mopArgs.eBoreDepth    -sticky e

# The name of the file that is sourced when mop RUN button pressed
set mopRunFile "makeHole.tcl"

# The name of the array containing the arguments
set mopName "hole"

# The name of the file that is sourced when mop HELP button pressed
set mopHelpFile "holeHelp.txt"

