# makeGrill.tcl
# Lawrence Glaister VE7IT Nov 2000
# drills an round array of holes for speaker/ventilation

# global variables
set X          0.0
set Y          0.0
set CurX       0.0
set CurY       0.0
set LineNo     10
set Num      [expr (($grill(Radius) / $grill(Incr)) + 1.0) ]
set RadSqr   [expr $grill(Radius) * $grill(Radius) ]

# Note, use append to build gcode argument to OutputCgode because 
# of better control of whitespaces.
# Lin Interp. and go to initial pos

# get drill to safe height
OutputGcode $mopText  [set gcode ""; append gcode\
    [GetLineNo] $sp\
    G0 $sp \
    Z [OutNum $grill(SafeZ) 4] $sp (retract_to_safe_height)] 

# set drilling speed
OutputGcode $mopText  [set gcode ""; append gcode\
    [GetLineNo] $sp\
    F [OutNum $grill(FeedRate) 1] $sp (set_drilling_rate)]   

puts "Drilling $Num x $Num circular array"    

for { set X -$Num }\
    { $X < $Num}\
    { set X [expr $X + 1.0] } {
      
    for { set Y -$Num }\
	    { $Y < $Num }\
	    { set Y [expr $Y + 1.0] } { 
    
        set CurY [expr $grill(CenterY) + $Y * $grill(Incr)]
        set CurX [expr $grill(CenterX) + $X * $grill(Incr)] 

        # we only drill holes with centers inside the specified radius
        if { [expr $CurX * $CurX + $CurY * $CurY] < $RadSqr } {

#           puts "drilling hole at $CurX,$CurY"  

            # fast seek to hole posn
            OutputGcode $mopText  [set gcode ""; append gcode\
	            [GetLineNo] $sp\
	            G0 $sp\
	            X [OutNum $CurX 4] $sp\
	            Y [OutNum $CurY 4]]

            # drill hole
            OutputGcode $mopText  [set gcode ""; append gcode\
	            [GetLineNo] $sp\
	            G1 $sp \
                Z [OutNum -$grill(HoleDepth) 4]]
        
            # fast retract drill
            OutputGcode $mopText  [set gcode ""; append gcode\
	            [GetLineNo] $sp\
	            G0 $sp \
                Z [OutNum $grill(SafeZ) 4]] 
            }   
        }
    }

