# makeRAHoles.tcl
# Lawrence Glaister VE7IT Nov 2000
# drilling g codes were not used in support of lowend machines

# make sure cpUtils.tcl has been sourced once
if ![info exists cpUtilsSourced] {
    source cpUtils.tcl
    puts "Sourced cpUtils.tcl"
}


# global variables
set X          ""
set Y          ""
set CurX       ""
set CurY       ""
set LineNo     10


# Note, use append to build gcode argument to OutputCgode because 
# of better control of whitespaces.
# Lin Interp. and go to initial pos

# get drill to safe height
OutputGcode $mopText  [set gcode ""; append gcode\
    [GetLineNo] $sp\
    G0 $sp \
    Z [OutNum $raholes(SafeZ) 4] $sp (set_to_safe_height)] 
    
#set drilling speed
OutputGcode $mopText  [set gcode ""; append gcode\
    [GetLineNo] $sp\
    F [OutNum $raholes(FeedRate) 1] $sp (set_drilling_rate)]     

for { set X 0 }\
    { $X < $raholes(NumX)}\
    { incr X } {
      
    for { set Y 0 }\
	    { $Y < $raholes(NumY) }\
	    { incr Y} { 
    
        set CurY [expr $raholes(StartY) + $Y * $raholes(IncrY)]
        set CurX [expr $raholes(StartX) + $X * $raholes(IncrX)] 

#        puts "drilling hole at $CurX,$CurY"  

        # fast seek to hole posn
        OutputGcode $mopText  [set gcode ""; append gcode\
	        [GetLineNo] $sp\
	        G0 $sp\
	        X [OutNum $CurX 4] $sp\
	        Y [OutNum $CurY 4]]

        # drill hole
        OutputGcode $mopText  [set gcode ""; append gcode\
	        [GetLineNo] $sp\
	        G1 $sp \
            Z [OutNum -$raholes(HoleDepth) 4]]
        
        # fast retract drill
        OutputGcode $mopText  [set gcode ""; append gcode\
	        [GetLineNo] $sp\
	        G0 $sp \
            Z [OutNum $raholes(SafeZ) 4]]    
        }
    }
