#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@"

# The arguments and gui for makePocket.
# milling an X by Y by depth pocket
# Sandor Szabo, NIST, 12/6/99

;;#######################################################################
if { ![info exists pocket(mopName)] || $pocket(mopName) == "" } {
    # init for convenience
    set pocket(mopName) "pocket"

    set pocket(llX) 1
    set pocket(llY) 2

    set pocket(Xsize) 3
    set pocket(Ysize) 4

    set pocket(ToolDia) .5
    set pocket(WidthOfCut) .25

    set pocket(FeedRate) 10

    set pocket(FinishFeed) 5
    set pocket(FinishWOC) .025

    set pocket(DepthPerPass) .1
    set pocket(Thickness) .2
    set pocket(Comment) "Mill a Rectangular Pocket"
}

;;#######################################################################
;# Build frame to enter mop parameters

set mopArgs [frame $cp.mopArgs -relief flat]

foreach field [array names pocket] {
#    puts $field
    label $mopArgs.l$field -text $field -anchor w
    entry $mopArgs.e$field -textvariable pocket($field) -relief sunken
}
# Put arguments two to a row.  
grid    $mopArgs.lComment   -sticky e
grid    $mopArgs.eComment  -row 0 -column 1   -sticky nsew
grid configure $mopArgs.eComment -columnspan 3
grid    $mopArgs.lllX          $mopArgs.ellX          \
	$mopArgs.lllY          $mopArgs.ellY          -sticky e
grid    $mopArgs.lXsize        $mopArgs.eXsize        \
	$mopArgs.lYsize        $mopArgs.eYsize        -sticky e
grid    $mopArgs.lToolDia      $mopArgs.eToolDia      \
	$mopArgs.lWidthOfCut   $mopArgs.eWidthOfCut   -sticky e
grid    $mopArgs.lFeedRate     $mopArgs.eFeedRate     \
	-sticky e
grid    $mopArgs.lFinishFeed   $mopArgs.eFinishFeed   \
	$mopArgs.lFinishWOC    $mopArgs.eFinishWOC    -sticky e
grid    $mopArgs.lDepthPerPass $mopArgs.eDepthPerPass \
	$mopArgs.lThickness    $mopArgs.eThickness    -sticky e


# The name of the file that is sourced when mop RUN button pressed
set mopRunFile "makePocket.tcl"

# The name of the array containing the arguments
set mopName "pocket"

# The name of the file that is sourced when mop HELP button pressed
set mopHelpFile "pocketHelp.txt"

