#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@"

# The arguments and gui for makeRAHoles.
# a rectangular array of holes
# Lawrence Glaister VE7IT  Nov 2000

;;#######################################################################
if { ![info exists raholes(mopName)] || $raholes(mopName) == "" } {
    # init for convenience
    set raholes(mopName) "RAHoles"
    set raholes(StartX) 0
    set raholes(StartY) 0
    set raholes(IncrX) 1.0
    set raholes(IncrY) 1.0
    set raholes(NumX) 3
    set raholes(NumY) 5 
    set raholes(HoleDepth) 0.5
    set raholes(SafeZ) 0.25
    set raholes(FeedRate) 5
    set raholes(Comment) "Drill Rectangular Array of Holes"
}

;;#######################################################################
;# Build frame to enter mop parameters

set mopArgs [frame $cp.mopArgs -relief raised -borderwidth 4]

foreach field [array names raholes] {
#    puts $field
    label $mopArgs.l$field -text $field -anchor w
    entry $mopArgs.e$field -textvariable raholes($field) -relief sunken
}

# Put arguments two to a row. 
grid    $mopArgs.lComment -sticky e
grid    $mopArgs.eComment  -row 0 -column 1   -sticky nsew
grid configure $mopArgs.eComment -columnspan 3
 
grid    $mopArgs.lStartX     $mopArgs.eStartX      \
	    $mopArgs.lStartY     $mopArgs.eStartY      -sticky e

grid    $mopArgs.lIncrX      $mopArgs.eIncrX       \
	    $mopArgs.lIncrY      $mopArgs.eIncrY       -sticky e

grid    $mopArgs.lNumX      $mopArgs.eNumX         \
	    $mopArgs.lNumY      $mopArgs.eNumY         -sticky e

grid    $mopArgs.lHoleDepth $mopArgs.eHoleDepth    \
        $mopArgs.lSafeZ     $mopArgs.eSafeZ        -sticky e

grid    $mopArgs.lFeedRate   $mopArgs.eFeedRate    -sticky e


# The name of the file that is sourced when mop RUN button pressed
set mopRunFile "makeRAHoles.tcl"

# The name of the array containing the arguments
set mopName "raholes"

# The name of the file that is sourced when mop HELP button pressed
set mopHelpFile "RAHolesHelp.txt"

