#!/bin/sh
# the next line restarts using wish\
exec wish "$0" "$@"

# The arguments and gui for engraving a round bezel
# written by
# Lawrence Glaister VE7IT  Nov 2000 lg@jfm.bc.ca

;;#######################################################################
if { ![info exists rbezel(mopName)] || $rbezel(mopName) == "" } {
    # init for convenience
    set rbezel(mopName) "RBezel"
    set rbezel(CenterX) 2.0
    set rbezel(CenterY) 2.0
    
    set rbezel(ArcRadius) 1.6
    set rbezel(MinorRadius) 1.8
    set rbezel(MajorRadius) 2.0
    
    set rbezel(StartAngle) -60.0
    set rbezel(EndAngle) 240.0
    
    set rbezel(NumTicks) 37
    set rbezel(MajorEvery) 4
    
    set rbezel(SafeZ) 0.25
    set rbezel(CutZ)  -0.050
    
    set rbezel(FeedRate) 10
    set rbezel(Comment) "RBezel - Engrave Round Graduated Bezel"
}

;;#######################################################################
;# Build frame to enter mop parameters

set mopArgs [frame $mop.mopArgs -relief flat]

foreach field [array names rbezel] {
#    puts $field
    label $mopArgs.l$field -text $field -anchor w
    entry $mopArgs.e$field -textvariable rbezel($field) -relief sunken
}

# full line for comment
grid    $mopArgs.lComment      -sticky e
grid    $mopArgs.eComment  -row 0 -column 1   -sticky nsew
grid configure $mopArgs.eComment -columnspan 3

# Put arguments two to a row.



grid    $mopArgs.lCenterX       $mopArgs.eCenterX       \
	    $mopArgs.lCenterY       $mopArgs.eCenterY       -sticky e

grid    $mopArgs.lArcRadius     $mopArgs.eArcRadius     -sticky e 

grid    $mopArgs.lMinorRadius   $mopArgs.eMinorRadius   \
	    $mopArgs.lMajorRadius   $mopArgs.eMajorRadius   -sticky e

grid    $mopArgs.lStartAngle    $mopArgs.eStartAngle    \
	    $mopArgs.lEndAngle      $mopArgs.eEndAngle      -sticky e

grid    $mopArgs.lNumTicks      $mopArgs.eNumTicks      \
	    $mopArgs.lMajorEvery    $mopArgs.eMajorEvery    -sticky e

grid    $mopArgs.lSafeZ         $mopArgs.eSafeZ         \
        $mopArgs.lCutZ          $mopArgs.eCutZ          -sticky e

grid    $mopArgs.lFeedRate      $mopArgs.eFeedRate      -sticky e

# The name of the file that is sourced when mop RUN button pressed
set mopRunFile "makeRBezel.tcl"

# The name of the array containing the arguments
set mopName "rbezel"

# The name of the file that is sourced when mop HELP button pressed
set mopHelpFile "RBezelHelp.txt"

