
# size is an arbitrary value used by switch command

proc exSetSize {size} {
    global top programfileframe textwin fontsize fontstyle
    global wmgeom popinheight popinwidth downheight oridescale oridescalelength
    global textwidth textheight editwidth editheight sfontsize
    switch -- $size {
        1 {
            set wmgeom 632x420+0+0
            set popinwidth "425"
            set popinheight "247"
            set downheight "140"
            set oridescalelength "186"
            set fontsize "24"
            set fontstyle "bold"
            set textwidth "70"
            set textheight "7"
            set editwidth "62"
            set editheight "16"
            set sfontsize "10"
        }
        2 {
            set wmgeom 792x543+0+0
            set popinwidth "548"
            set popinheight "330"
            set downheight "180"
            set oridescalelength "234"
            set fontsize "36"
            set fontstyle "bold"
            set textwidth "60"
            set textheight "10"
            set editwidth "80"
            set editheight "22"
            set sfontsize "12"
        }
        3 {
            set wmgeom 1015x707+0+0
            set popinwidth "640"
            set popinheight "470"
            set downheight "200"
            set oridescalelength "364"
            set fontsize "56"
            set fontstyle "bold"
            set textwidth "80"
            set textheight "12"
            set editwidth "80"
            set editheight "24"
            set sfontsize "14"
        }
        4 {
            set wmgeom 640x440+0+0
            set popinwidth "10"
            set popinheight "10"
            set downheight "10"
            set oridescalelength "400"
            set fontsize "56"
            set fontstyle "bold"
            set textwidth "800"
            set editwidth "60"
            set editheight "20"
            set textheight "14"
            set editwidth "60"
            set editheight "20"
            set sfontsize "10"
        }
        x {

        }

    }

    foreach widgetset {.top.up .top.down.set} {
        foreach widget [winfo children $widgetset] {
            catch [$widget configure -font "-*-helvetica-bold-r-normal-*-$sfontsize-*-*-*-*-*-*-*"]
        }
    }
    wm geometry . $wmgeom
    grid columnconfigure $top 1 -minsize $popinwidth
    grid rowconfigure $top 1 -minsize $popinheight
    grid rowconfigure $top 3 -minsize $downheight
    $programfileframe.text configure -height $textheight -width $textwidth
    $oridescale configure -length $oridescalelength
    setfontx
}

proc popinSetSize {} {
    global popinframe
    global top programfileframe textwin fontsize fontstyle
    global wmgeom popinheight popinwidth downheight oridescalelength
    global textwidth textheight editwidth editheight sfontsize


    set setsize [frame $popinframe.setsize]
    pack $setsize -fill both

    set l0 [label $setsize.l0 -text "Window Geometry" -anchor e]
    set l1 [label $setsize.l1 -text "popin width"  -anchor e]
    set l2 [label $setsize.l2 -text "popin height"  -anchor e]
    set l3 [label $setsize.l3 -text "bottom height"  -anchor e]
    set l4 [label $setsize.l4 -text "override scale length"  -anchor e]
    set l5 [label $setsize.l5 -text "position font size"  -anchor e]
    set l6 [label $setsize.l6 -text "Width of auto text display"  -anchor e]
    set l7 [label $setsize.l7 -text "lines of auto text"  -anchor e]
    set l8 [label $setsize.l8 -text "Width of edit text display"  -anchor e]
    set l9 [label $setsize.l9 -text "Lines of edit text"  -anchor e]
    set l10 [label $setsize.l10 -text "Small Font Size"  -anchor e]

    set e0 [entry $setsize.e0 -textvariable wmgeom]
    set e1 [entry $setsize.e1 -textvariable popinwidth]
    set e2 [entry $setsize.e2 -textvariable popinheight]
    set e3 [entry $setsize.e3 -textvariable downheight]
    set e4 [entry $setsize.e4 -textvariable oridescalelength]
    set e5 [entry $setsize.e5 -textvariable fontsize]
    set e6 [entry $setsize.e6 -textvariable textwidth]
    set e7 [entry $setsize.e7 -textvariable textheight]
    set e8 [entry $setsize.e8 -textvariable editwidth]
    set e9 [entry $setsize.e9 -textvariable editheight]
    set e10 [entry $setsize.e10 -textvariable sfontsize]

    grid $l0 $e0 -sticky nsew
    grid $l1 $e1 -sticky nsew
    grid $l2 $e2 -sticky nsew
    grid $l3 $e3 -sticky nsew
    grid $l4 $e4 -sticky nsew
    grid $l5 $e5 -sticky nsew
    grid $l6 $e6 -sticky nsew
    grid $l7 $e7 -sticky nsew
    grid $l8 $e8 -sticky nsew
    grid $l9 $e9 -sticky nsew
    grid $l10 $e10 -sticky nsew

    set test [button $setsize.b1 -text "Test Settings" -command {exSetSize x}]
    set ok [button $setsize.b2 -text "OK" -command "killPopin $setsize"]
    grid $test $ok -sticky nsew

}
