
# pop up the info table editor
proc popinInfo {} {
    global infofilename popinframe editwidth editheight
    set infofilename [pwd]/tcl/info.txt
    if {![info exists popinframe]} {
        set w ""
    } else {
        set w $popinframe
    }

    # create an editor as "$w.infoEditor"
    if {[file isfile $infofilename]} {
        geneditStart $w.infoEditor $infofilename
    } else {
        geneditStart $w.infoEditor "untitled.txt"
    }
    set infocmd "info vars"
    set b [frame $w.infoEditor.buttons]
    pack $w.infoEditor.buttons -side bottom -fill x -pady 2
    entry $b.entry -textvariable infocmd
    checkbutton $b.sortinfo -text "sort"
    checkbutton $b.lineinfo -text "newline"
    button $b.ex -text "Execute" -command {
        set selecttext [eval $infocmd]
        if {$sortinfo == 1} {
            set selecttext [lsort $selecttext]
        }
        if {$lineinfo == 1} {
            set selecttext [join $selecttext " \n"]
        }
        geneditPasteIt $textwin
    }

    button $b.cancel -text "Cancel" -default active -command "killPopin $w.infoEditor"
    pack $b.entry $b.sortinfo $b.lineinfo $b.ex $b.cancel -side left -expand 1

    # Each time this window is popped up it resets the text widget size
    $w.infoEditor.textframe.textwin configure -width $editwidth -height $editheight

}

proc infoEntry {cmd} {
    global selecttext textwin
    set selecttext [eval $cmd]
    geneditPasteIt $textwin
}
