
# pop up the parameter file editor
proc popinParamEditor {} {
    global paramfilename popinframe editwidth editheight

    if {![info exists popinframe]} {
        set w ""
    } else {
        set w $popinframe
    }

    # create an editor as $w.paramEditor"
    if {[file isfile $paramfilename]} {
        geneditStart $w.paramEditor $paramfilename
    } else {
        geneditStart $w.paramEditor "untitled.var"
    }

    # disable "Save As..." menu, since we don't support changing it
    $w.paramEditor.menubar.file entryconfigure 3 -state disabled

    frame $w.paramEditor.buttons
    pack $w.paramEditor.buttons -side bottom -fill x -pady 2
    button $w.paramEditor.buttons.load -text "Load Parameter File" -command "geneditSaveFile $w.paramEditor ; emc_task_plan_init"
    button $w.paramEditor.buttons.cancel -text "Cancel" -default active -command "killPopin $w.paramEditor"
    pack $w.paramEditor.buttons.load $w.paramEditor.buttons.cancel -side left -expand 1

    # Each time this window is popped up it resets the text widget size
    $w.paramEditor.textframe.textwin configure -width $editwidth -height $editheight
}

set helpfilename [emc_ini "HELP_FILE" "DISPLAY"]
if {[string length $helpfilename] == 0} {
    set helpfilename "doc/help.txt"
}
