
# pop up the program editor

proc popinProgramEditor {} {
    global programnamestring popinframe editwidth editheight startnumbering menubar

    if {![info exists popinframe]} {
        set w ""
    } else {
        set w $popinframe
    }

    # create an editor as  "$w.programEditor"
    if {[file isfile $programnamestring]} {
        geneditStart $w.programEditor $programnamestring
    } else {
        geneditStart $w.programEditor "untitled.ngc"
    }

    set name "$w.programEditor"
    set editor "$name.menubar"
    set filemenu "$editor.file"
    set editmenu "$editor.edit"
    set settingsmenu "$editor.settings"
    set scriptmenu "$editor.script"
    set textwin $name.textframe.textwin

    # Extra menu items for program editor
    $filemenu add separator
    $filemenu add command -label "Save and Reload" -command "geneditSaveFile $name; loadProgramText" -underline 1

    $editmenu add separator
    $editmenu add command -label "Find Text" -underline 0 \
        -command "geneditEnterText $textwin"
    $editmenu add command -label "Renumber File" -underline 0 \
        -command "geneditNumber"

    menu $settingsmenu -tearoff 0
    $editor add cascade -label "Settings" -menu $settingsmenu -underline 0
    $settingsmenu add command -label "No Numbering" -underline 0 \
        -command "set startnumbering 0"
    $settingsmenu add separator
    $settingsmenu add command -label "Line Numbering" -underline 0 \
        -command "geneditSetLineNumber"

    # adds a script menu that looks for *.ncw files and adds their filename to script menu
    menu $scriptmenu
    $editor add cascade -label "Scripts" -menu $scriptmenu -underline 1
        set scriptdir tcl/scripts
    set files [exec /bin/ls $scriptdir]
    foreach file $files {
        if {[string match *.ncw $file]} {
            set geneditfname [file rootname $file]
            $scriptmenu add command -label $geneditfname -command "source $scriptdir/$file"
        }
    }

    set controls [frame $w.programEditor.buttons ]
    pack $controls -side bottom -fill x -pady 2
    button $controls.save -text "Save and Load" -command "geneditSaveFile $name; loadProgramText"
    button $controls.mark -text "Set Run Mark" -command {popupRunMark [int [$textwin index insert]]}
    button $controls.cancel -text "Cancel" -command "killPopin $w.programEditor"
    pack $controls.save $controls.mark $controls.cancel -side left -expand 1

    # Each time this window is popped up it resets the text widget size
    $w.programEditor.textframe.textwin configure -width $editwidth -height $editheight

}

