
proc updateStatus2 {} {
    global emc_teleop_enable_command_given
    global lastjointworld lastactcmd lastcoords
    global displayCycleTime
    global mistbutton floodbutton spindlebutton brakebutton
    global modeInDisplay
    global estoplabel modelabel mistlabel floodlabel lubelabel spindlelabel brakelabel
    global toolsetting tooloffsetsetting offsetsetting
    global unitlabel unitsetting oldunitsetting
    global actcmd coords jointworld axiscoordmap worldlabellist

    global posnames
    foreach item $posnames {
        global $item
    }

    global radiorel radiocmd radioact radioabs
    global limoridebutton limoridebuttonbg limoridebuttonabg stopbutton
    global realfeedoverride feedoverride syncingFeedOverride
    global mdientry
    global programcodestring
    global programnamestring programin activeLine programstatusstring
    global programfiletext
    global taskhb taskcmd tasknum taskstatus
    global iohb iocmd ionum iostatus
    global motionhb motioncmd motionnum motionstatus
    global oldstatusstring jogSpeed
    global axiscoordmap
    global popinframe feedholdbutton stopbutton feedtext
    global isnew oldmode workoffsets defbg

    # force an update of error log
    set thisError [emc_error]
    if {$thisError != "ok"} {
        popupError $thisError
    }

    # force an update of operator information messages
    set thisError [emc_operator_text]
    if {$thisError != "ok"} {
        popupOperatorText $thisError
    }

    # force an update of operator request messages
    set thisError [emc_operator_display]
    if {$thisError != "ok"} {
        popupOperatorDisplay $thisError
    }

    # force an update of status
    emc_update

    # now update labels

    if {[emc_estop] == "on"} {
        set estoplabel "ESTOP"
        $stopbutton configure -bg gray -fg black -relief sunken
    } elseif {[emc_machine] == "on"} {
        set estoplabel "ON"
        $stopbutton configure -bg red -fg black -relief raised
    } else {
        set estoplabel "ESTOP RESET"
        $stopbutton configure -bg green -fg black -relief sunken
    }

    if {[emc_mist] == "on"} {
        set mistlabel "MIST ON"
    } elseif {[emc_mist] == "off"} {
        set mistlabel "MIST OFF"
    } else {
        set mistlabel "MIST ?"
    }

    if {[emc_flood] == "on"} {
        set floodlabel "FLOOD ON"
    } elseif {[emc_flood] == "off"} {
        set floodlabel "FLOOD OFF"
    } else {
        set floodlabel "FLOOD ?"
    }

    if {[emc_lube] == "on"} {
        set lubelabel "LUBE ON"
    } elseif {[emc_lube] == "off"} {
        set lubelabel "LUBE OFF"
    } else {
        set lubelabel "LUBE ?"
    }

    if {[emc_spindle] == "forward"} {
        set spindlelabel "SPINDLE FORWARD"
    } elseif {[emc_spindle] == "reverse"} {
        set spindlelabel "SPINDLE REVERSE"
    } elseif {[emc_spindle] == "off"} {
        set spindlelabel "SPINDLE OFF"
    } elseif {[emc_spindle] == "increase"} {
        set spindlelabel "SPINDLE INCREASE"
    } elseif {[emc_spindle] == "decrease"} {
        set spindlelabel "SPINDLE DECREASE"
    } else {
        set spindlelabel "SPINDLE ?"
    }

    if {[emc_brake] == "on"} {
        set brakelabel "BRAKE ON"
    } elseif {[emc_brake] == "off"} {
        set brakelabel "BRAKE OFF"
    } else {
        set brakelabel "BRAKE ?"
    }

    # set the unit information
    if {$isnew != "old"} {
        catch {set unitsetting [emc_display_linear_units]}
        if {$oldunitsetting != $unitsetting} {
            set oldunitsetting $unitsetting
            set_balloon $unitlabel [unithelp $unitsetting]
        }
    }

    # set the tool information
    set toolsetting [emc_tool]
    set tooloffsetsetting [format "%.4f" [emc_tool_offset]]

    set temp [emc_mode]
    if {$temp != $modeInDisplay} {
        showMode $temp
        if {$temp == "auto"} {
            $mdientry config -state disabled
            focus .
            setAutoBindings
        } elseif {$temp == "mdi"} {
            focus $mdientry
            $mdientry select range 0 end
            setMdiBindings
        } else {
            focus .
            setManualBindings
        }
        set modeInDisplay $temp
    }

    if {$jointworld == "joint" } {
    	if { $lastjointworld != "joint" } {
            foreach axnum $axiscoordmap {
                set "poslabel${axnum}" [set "jointlabel${axnum}"]
            }
            set lastactcmd $actcmd
            set lastcoords $coords
    	    set actcmd "actual"
            set coords "machine"
            $radiorel config -state disabled
    	    $radioabs config -state disabled
            $radioact config -state disabled
            $radiocmd config -state disabled
    	    set lastjointworld $jointworld
            if { [emc_teleop_enable] == 1  && $modeInDisplay == "manual" } {
            	emc_teleop_enable 0
                set emc_teleop_enable_command_given 0
            }
        }
        foreach axnum $axiscoordmap {
            set "posdigit${axnum}" [format "%9.4f" [emc_joint_pos ${axnum}] ]
        }
    } else {
        if { $lastjointworld != "world" } {
            if { [emc_teleop_enable] == 0  && [emc_kinematics_type] != 1 && $modeInDisplay == "manual" } {
    	        if { $emc_teleop_enable_command_given == 0 } {
    	            emc_teleop_enable 1
        	        set emc_teleop_enable_command_given 1
                } else {
                    set jointworld "joint"
                    set emc_teleop_enable_command_given 0
                }
            } else {
                foreach axnum $axiscoordmap {
                    set "poslabel${axnum}" [set "worldlabel${axnum}"]
                }
                foreach axname $worldlabellist {
                    set temp "[emc_pos_offset ${axname}]"
                }
                set actcmd $lastactcmd
                set coords $lastcoords
                $radiorel config -state normal
                $radioabs config -state normal
                $radioact config -state normal
                $radiocmd config -state normal
                set lastjointworld $jointworld
            }
        }
        if { $lastjointworld == "world" } {
            if {$coords == "relative" && $actcmd == "commanded"} {
                set whizbang {emc_rel_cmd_pos}
            } elseif {$coords == "relative" && $actcmd == "actual"} {
                set whizbang {emc_rel_act_pos}
            } elseif {$coords == "machine" && $actcmd == "commanded"} {
                set whizbang {emc_abs_cmd_pos}
            } else {
                set whizbang {emc_abs_act_pos}
            }
            foreach axnum $axiscoordmap {
                set posdigit${axnum} [format "%9.4f" [eval $whizbang $axnum]]
            }
        }
    }

    # set the offset information
    set offsetsetting ""
    foreach axname $worldlabellist {
        set temp [format "${axname}%.4f" [emc_pos_offset $axname] ]
        set offsetsetting  "$offsetsetting [join $temp ]"
    }


    # color the numbers
    foreach axnum $axiscoordmap {
        if {[emc_joint_limit ${axnum} ] != "ok"} {
            [set "pos${axnum}l"] config -foreground red
            [set "pos${axnum}d"] config -foreground red
        } elseif {[emc_joint_homed ${axnum} ] == "homed"} {
            [set "pos${axnum}l"] config -foreground green
            [set "pos${axnum}d"] config -foreground green
        } else {
            [set "pos${axnum}l"] config -foreground yellow
            [set "pos${axnum}d"] config -foreground yellow
        }
    }

    # color the limit override button red if active
    if {[emc_override_limit]} {
        $limoridebutton config -background red
        $limoridebutton config -activebackground red
    } else {
        $limoridebutton config -background $limoridebuttonbg
        $limoridebutton config -activebackground $limoridebuttonabg
    }

    # set the feed override
    set realfeedoverride [emc_feed_override]
    if {$realfeedoverride == 0} {
            $feedholdbutton configure -bg green -activebackground green  -fg black -activeforeground darkgray
            set feedtext "CONTINUE"
    } else {
            $feedholdbutton configure -bg red -activebackground red -fg black -activeforeground white
             set feedtext "FEEDHOLD"
    }
    # do me
    if {$realfeedoverride != $feedoverride && $syncingFeedOverride == 0} {
        set syncingFeedOverride 1
        after $displayCycleTime syncFeedOverride
    }

    # temporary fix for 0 jog speed problem
    if {$jogSpeed <= 0} {set jogSpeed .000001}

    # fill in the program codes
    set programcodestring [emc_program_codes]

    # fill in the program status
    set oldstatusstring $programstatusstring
    set programstatusstring [emc_program_status]

    # load new program text on status change
    if {$oldstatusstring == "idle" && $programstatusstring == "running"} {
        loadProgramText
    }

    # update the current file name and load program text
    set temp [emc_program]
    if {$temp != $programnamestring} {
        if {$temp == "none"} {
        } else {
            set programnamestring $temp
            loadProgramText
        }
    }

    # highlight the active line
    set temp [emc_program_line]
    if {$temp != $activeLine} {
        $programfiletext tag remove highlight $activeLine.0 $activeLine.end
        set activeLine $temp
        $programfiletext tag add highlight $activeLine.0 $activeLine.end
    }

    # position text so line shows
    $programfiletext see [expr $activeLine.0 +1]

    # enable plotting if plotter exists
    if {[winfo exists $popinframe.plot]} {
        updatePlot
    }

   # get diagnostics info
    if {[winfo exists $popinframe.diag]} {
        set taskhb [emc_task_heartbeat]
        set taskcmd [emc_task_command]
        set tasknum [emc_task_command_number]
        set taskstatus [emc_task_command_status]
        set iohb [emc_io_heartbeat]
        set iocmd [emc_io_command]
        set ionum [emc_io_command_number]
        set iostatus [emc_io_command_status]
        set motionhb [emc_motion_heartbeat]
        set motioncmd [emc_motion_command]
        set motionnum [emc_motion_command_number]
        set motionstatus [emc_motion_command_status]
    }

# schedule this again
    after $displayCycleTime updateStatus2
}
