proc setManualBindings {} {
    bindtags . {ManualBindings . all}
}

proc setAutoBindings {} {
    bindtags . {AutoBindings . all}
}

proc setMdiBindings {} {
    bindtags . {. all}
}

proc setKeyBindings {} {
    global modifier
    bind . <KeyPress-F1> {toggleEstop}
    bind . <KeyPress-F2> {toggleMachine}
    bind . <KeyPress-F3> {emc_mode manual}
    bind . <KeyPress-F4> {emc_mode auto}
    bind . <KeyPress-F5> {emc_mode mdi}
    bind . <KeyPress-F6> {emc_task_plan_init}
    bind . <KeyPress-F10> {break}

    #bind ManualBindings <KeyPress-1> {emc_feed_override 10}
    #bind ManualBindings <KeyPress-2> {emc_feed_override 20}
    #bind ManualBindings <KeyPress-3> {emc_feed_override 30}
    #bind ManualBindings <KeyPress-4> {emc_feed_override 40}
    #bind ManualBindings <KeyPress-5> {emc_feed_override 50}
    #bind ManualBindings <KeyPress-6> {emc_feed_override 60}
    #bind ManualBindings <KeyPress-7> {emc_feed_override 70}
    #bind ManualBindings <KeyPress-8> {emc_feed_override 80}
    #bind ManualBindings <KeyPress-9> {emc_feed_override 90}
    #bind ManualBindings <KeyPress-0> {emc_feed_override 100}
    # These key bindings really needed to be changed for 6 axis operation.
    bind ManualBindings <KeyPress-0> {axisSelect 0}
    bind ManualBindings <KeyPress-grave> {axisSelect 0}
    bind ManualBindings <KeyPress-1> {axisSelect 1}
    bind ManualBindings <KeyPress-2> {axisSelect 2}
    bind ManualBindings <KeyPress-3> {axisSelect 3}
    bind ManualBindings <KeyPress-4> {axisSelect 4}
    bind ManualBindings <KeyPress-5> {axisSelect 5}
    bind ManualBindings <KeyPress-at> {toggleCmdAct}
    bind ManualBindings <KeyPress-numbersign> {toggleRelAbs}
    bind ManualBindings <KeyPress-dollar> {toggleJointWorld}
    bind ManualBindings <KeyPress-comma> {decrJogSpeed}
    bind ManualBindings <KeyPress-period> {incrJogSpeed}
    bind ManualBindings <KeyPress-c> {toggleJogType}
    bind ManualBindings <KeyPress-i> {toggleJogIncrement}
    bind ManualBindings <KeyPress-x> {axisSelect 0}
    bind ManualBindings <KeyPress-y> {axisSelect 1}
    bind ManualBindings <KeyPress-z> {axisSelect 2}
    bind ManualBindings <$modifier-t> {popupToolOffset}
    bind ManualBindings <KeyPress-b> {emc_brake off}
    bind ManualBindings <Shift-KeyPress-B> {emc_brake on}
    bind ManualBindings <$modifier-t> {popupToolOffset}
    bind ManualBindings <KeyPress-F7> {toggleMist}
    bind ManualBindings <KeyPress-F8> {toggleFlood}
    bind ManualBindings <KeyPress-F9> {toggleSpindleForward}
    bind ManualBindings <KeyPress-F10> {toggleSpindleReverse}
    bind ManualBindings <Home> {emc_home $activeAxis}

    bind AutoBindings <KeyPress-1> {emc_feed_override 10}
    bind AutoBindings <KeyPress-2> {emc_feed_override 20}
    bind AutoBindings <KeyPress-3> {emc_feed_override 30}
    bind AutoBindings <KeyPress-4> {emc_feed_override 40}
    bind AutoBindings <KeyPress-5> {emc_feed_override 50}
    bind AutoBindings <KeyPress-6> {emc_feed_override 60}
    bind AutoBindings <KeyPress-7> {emc_feed_override 70}
    bind AutoBindings <KeyPress-8> {emc_feed_override 80}
    bind AutoBindings <KeyPress-9> {emc_feed_override 90}
    bind AutoBindings <KeyPress-0> {emc_feed_override 100}
    bind AutoBindings <KeyPress-at> {toggleCmdAct}
    bind AutoBindings <KeyPress-numbersign> {toggleRelAbs}
    bind AutoBindings <KeyPress-o> {fileDialog}
    bind AutoBindings <KeyPress-r> {emc_run $runMark ; set runMark 0}
    bind AutoBindings <KeyPress-p> {emc_pause}
    bind AutoBindings <KeyPress-s> {emc_resume}
    bind AutoBindings <KeyPress-a> {emc_step}
    bind AutoBindings <KeyPress-v> {emc_run -1}
    bind AutoBindings <$modifier-t> {popupToolOffset}

    bind ManualBindings <KeyPress-F11> spindleDecrDown
    bind ManualBindings <KeyRelease-F11> spindleDecrUp
    bind ManualBindings <KeyPress-F12> spindleIncrDown
    bind ManualBindings <KeyRelease-F12> spindleIncrUp
    bind ManualBindings <KeyPress-minus> minusDown
    bind ManualBindings <KeyRelease-minus> minusUp
    bind ManualBindings <KeyPress-equal> equalDown
    bind ManualBindings <KeyRelease-equal> equalUp
    bind ManualBindings <KeyPress-Left> leftDown
    bind ManualBindings <KeyRelease-Left> leftUp
    bind ManualBindings <KeyPress-Right> rightDown
    bind ManualBindings <KeyRelease-Right> rightUp
    bind ManualBindings <KeyPress-Down> downDown
    bind ManualBindings <KeyRelease-Down> downUp
    bind ManualBindings <KeyPress-Up> upDown
    bind ManualBindings <KeyRelease-Up> upUp
    bind ManualBindings <KeyPress-Prior> priorDown
    bind ManualBindings <KeyRelease-Prior> priorUp
    bind ManualBindings <KeyPress-Next> nextDown
    bind ManualBindings <KeyRelease-Next> nextUp

    bind . <Escape> {emc_abort}
}