#!/bin/sh
# the next line restarts using emcsh \
exec plat/nonrealtime/bin/emcsh "$0" "$@"

# TclTk script for tkemc gui

# Notes
# This script allows the user to send some fairly low-level
#  probing commands and veiw the probing status of EMC.
#
#

wm title . "Probe Control"
global int probeval
set probeval 0
global int probeindex
set probeindex 0
global int probepolarity
set probepolarity 0
global int probetripped
set probetripped 0
global double goto_x
global double goto_y
global double goto_z
set goto_x 0
set goto_y 0
set goto_z 0
global double probed_x
global double probed_y
global double probed_z
set probed_x 0
set probed_y 0
set probed_z 0
global string propedpos


# create the main window top frame
set top [frame .probeshow]
pack $top

message $top.message1 -text "Probe Data" \
   -justify center
pack $top.message1

set valline [frame .probeshow.valline]
pack $valline
label $top.probevallabel -text "Probe Value"
entry $top.probevalentry -textvariable probeval

pack $top.probevallabel $top.probevalentry -side left -in $valline


set indexline [frame .probeshow.indexline]
pack $indexline
label $top.probeindexlabel -text "Probe Index"
entry $top.probeindexentry -textvariable probeindex
entry $top.probeindexsetentry -textvariable probeindexset
button $top.probeindexsetbutton -text "Set" -command {emc_probe_index $probeindexset}

pack $top.probeindexlabel $top.probeindexentry $top.probeindexsetentry $top.probeindexsetbutton -side left -in $indexline

set polarityline [frame .probeshow.polarityline]
pack $polarityline
label $top.probepolaritylabel -text "Probe Polarity"
entry $top.probepolarityentry -textvariable probepolarity
entry $top.probepolaritysetentry -textvariable probepolarityset
button $top.probepolaritysetbutton -text "Set" -command {emc_probe_polarity $probepolarityset}

pack $top.probepolaritylabel $top.probepolarityentry $top.probepolaritysetentry $top.probepolaritysetbutton -side left -in $polarityline

set trippedline [frame .probeshow.trippedline]
pack $trippedline
label $top.probetrippedlabel -text "Probe Tripped"
entry $top.probetrippedentry -textvariable probetripped
button $top.clearprobetrippebutton -text "Clear" -command {emc_probe_clear}
pack $top.probetrippedlabel $top.probetrippedentry $top.clearprobetrippebutton -side left -in $trippedline


set gotoline [frame .probeshow.gotoline]
pack $gotoline
label $top.probegotolabel -text "Probe Goto"
entry $top.probegotoxentry -textvariable goto_x
entry $top.probegotoyentry -textvariable goto_y
entry $top.probegotozentry -textvariable goto_z
button $top.probegotobutton -text "Go" -command {emc_probe_move $goto_x $goto_y $goto_z}
pack $top.probegotolabel $top.probegotoxentry $top.probegotoyentry $top.probegotozentry $top.probegotobutton -side left -in $gotoline

set probedposline [frame .probeshow.probedposline]
pack $probedposline
label $top.probedposlabel -text "Last Probed Position"
entry $top.probedposentryx -textvariable probedposx
entry $top.probedposentryy -textvariable probedposy
entry $top.probedposentryz -textvariable probedposz

pack $top.probedposlabel $top.probedposentryx  $top.probedposentryy $top.probedposentryz  -side left -in $probedposline


# 'probeUpdate' updates the dynamic value repeatedly
proc probeUpdate {} {
    global probeval probeindex probepolarity probetripped probedposx probedposy probedposz
    set probeval [emc_probe_value]
    set probeindex [emc_probe_index]
    set probepolarity [emc_probe_polarity]
    set probetripped [emc_probe_tripped]
    set probedposx [emc_probed_pos 0]
    set probedposy [emc_probed_pos 1]
    set probedposz [emc_probed_pos 2]


    # schedule this again
    after 100 probeUpdate
}

# start it
probeUpdate





