#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

# Tcl/Tk window to show EMC and system information.

wm title . "EMC System Information"
set top [frame .info]
set itext [text $top.text  -width 80 -height 24 -padx 4 -wrap word \
    -yscrollcommand { $top.ysbar set}]
scrollbar $top.ysbar -orient vertical -command {$itext yview}

set ib [frame .info.buttons ]
$itext insert end "\n ----- EMC Information ----- \n"
$itext insert end [exec /bin/cat emcversion]
    button $ib.ok -default active -text Done -command "destroy ."
    button $ib.ver -text "System" -command "findInfo $itext version"
    button $ib.cpu -text "CPU" -command "findInfo $itext cpuinfo"
    button $ib.mem -text "Memory" -command "findInfo $itext meminfo"
    button $ib.int -text "Interrupts" -command "findInfo $itext interrupts"
    button $ib.mod -text "Modules" -command "findInfo $itext modules"
    button $ib.write -text "Save" -command "infoSaveFile $itext"

    pack $itext $top.ysbar -side left -fill y -expand yes
    pack $ib.ver $ib.cpu $ib.mem $ib.int $ib.mod $ib.write $ib.ok \
        -side top -fill x -expand 1
        pack $ib -side left
    pack .info
    bind .info <Return> "destroy ."

proc findInfo {textwidget which} {
    $textwidget insert end "\n\n ----- $which information ----- \n"
    $textwidget insert end [exec /bin/cat /proc/$which]
    $textwidget see end
}

proc infoSaveFile {textwidget} {
    set fileout emcinfo
    catch {file copy -force $fileout $fileout.bak}
    if {[catch {open $fileout w} fileout]} {
puts stdout "can't save $fileout)"
return
    }
    puts $fileout [$textwidget get 1.0 end]
    catch {close $fileout}
}
